//+------------------------------------------------------------------+
//|                                                      MTF WPR.mq4 |
//|                                         Copyright  2009, matfx  |
//|                                        http://www.forex-tsd.com  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, matfx"
#property link      "http://www.forex-tsd.com"

#property indicator_separate_window
#property indicator_minimum -100
#property indicator_maximum 0
#property indicator_buffers 1
#property indicator_color1 DodgerBlue
#property indicator_level1 -20
#property indicator_level2 -80

//---- input parameters
extern int ExtWPRPeriod = 14;
//---- buffers
double ExtWPRMapBuffer[];

extern int TimeFrame=0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {


//---- indicator line

SetIndexBuffer(0, ExtWPRMapBuffer);
SetIndexStyle(0, DRAW_LINE);

//---- name for DataWindow and indicator subwindow label   
   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   } 
   IndicatorShortName("MTF_WPR(" + ExtWPRPeriod + ")("+TimeFrameStr+")");  
  }
//----
   return(0);

//+------------------------------------------------------------------+
//| MTF Williams' Percent Range                                      |
//+------------------------------------------------------------------+
int start()
  {
   datetime TimeArray[];
   int    i,shift,limit,y=0,counted_bars=IndicatorCounted();
    
// Plot defined timeframe on to current timeframe   
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   
   limit=Bars-counted_bars+TimeFrame/Period();

   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray[y]) y++; 

/***********************************************************   
   Add your main indicator loop below.  You can reference an existing
      indicator with its iName  or iCustom.
   Rule 1:  Add extern inputs above for all neccesary values   
   Rule 2:  Use 'TimeFrame' for the indicator timeframe
   Rule 3:  Use 'y' for the indicator's shift value
 **********************************************************/  

ExtWPRMapBuffer[i]=iCustom(NULL,TimeFrame,"WPR",0,y);


   }  
     
//
   
  
  
   return(0);
  }

//+------------------------------------------------------------------+